/*
    Copyright 2020. Huawei Technologies Co., Ltd. All rights reserved.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
*/
import 'dart:convert';

import 'Status.dart';

class IsEnvReadyResult {
  int returnCode;
  Status status;

  IsEnvReadyResult({
    this.returnCode,
    this.status,
  });

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['returnCode'] = this.returnCode;
    if (this.status != null) {
      data['status'] = this.status.toJson();
    }
    return data;
  }

  String toJson() => json.encode(toMap());

  factory IsEnvReadyResult.fromMap(Map<String, dynamic> map) {
    if (map == null) return null;
    return IsEnvReadyResult(
        returnCode: map["returnCode"] == null ? null : map["returnCode"],
        status: Status.fromJson(map['status']) == null
            ? null
            : Status.fromJson(map['status']));
  }

  factory IsEnvReadyResult.fromJson(String source) =>
      IsEnvReadyResult.fromMap(json.decode(source));
}
